<?php defined('SYSPATH') or die('No direct access allowed.');

/**
 * This class provides Reseller Account management
 *
 * @package    OSB
 * @category   Controllers/Reseller
 * @author     Deon George
 * @copyright  (c) 2009-2013 Open Source Billing
 * @license    http://dev.osbill.net/license.html
 */
class Controller_Reseller_Account extends Controller_Account {
	protected $secure_actions = array(
		'list'=>TRUE,
		'listlog'=>TRUE,
		'view'=>TRUE,
	);

	/**
	 * Show a list of accounts
	 */
	public function action_list() {
		$this->meta->title = 'R|Customer List';

		Block::factory()
			->title(_('Customer List'))
			->title_icon($this->icon)
			->body(View::factory('account/list')->set('o',ORM::factory('Account')->where_authorised($this->ao,'id')->find_all()));
	}

	/**
	 * Show a list of account logins
	 */
	public function action_listlog() {
		$this->meta->title = 'R|Customer Logins';

		Block::factory()
			->title(_('Customer List'))
			->title_icon('fa fa-eye')
			->body(View::factory('account/listlog')->set('o',ORM::factory('Account_Log')->where_authorised($this->ao)->find_all()));
	}

	public function action_view() {
		$ao = ORM::factory('Account',$this->request->param('id'));

		if (! $ao->loaded() OR ! $ao->active OR ! Auth::instance()->authorised($ao))
			throw HTTP_Exception::factory(403,'Account either doesnt exist, or you are not authorised to see it');

		$this->meta->title = 'Customer: '.$ao->name();

		$this->template->content = View::factory('account/reseller/view')->set('o',$ao);
	}
}
?>
