<?php defined('SYSPATH') or die('No direct access allowed.');

/**
 * This class provides User Email View functions
 *
 * @package    Email
 * @category   Controllers/User
 * @author     Deon George
 * @copyright  (c) 2009-2013 Open Source Billing
 * @license    http://dev.osbill.net/license.html
 */
class Controller_User_Email extends Controller_Email {
	protected $secure_actions = array(
		'list'=>TRUE,
		'view'=>TRUE,
	);

	/**
	 * Show a list of emails
	 */
	public function action_list() {
		$this->meta->title = 'Email List';

		Block::factory()
			->title(sprintf(_('System Emails Sent for %s: %s'),$this->ao->refnum(),$this->ao->name()))
			->title_icon($this->icon)
			->body(View::factory('email/user/list')->set('o',$this->ao->email_log->find_all()));
	}

	public function action_view() {
		list($id,$output) = Table::page(__METHOD__);

		$elo = ORM::factory('Email_Log',$id);

		if (! $elo->loaded() OR ! Auth::instance()->authorised($elo->account))
			throw HTTP_Exception::factory(403,'Service either doesnt exist, or you are not authorised to see it');

		$this->meta->title = 'Email: '.$elo->name();

		$output .= View::factory('email/user/view')
			->set('elo',$elo);

		Block::factory()
			->title(sprintf('%s: %s',$elo->id,$elo->resolve('subject')))
			->title_icon('icon-list-alt')
			->body($output);
	}
}
?>
