<?php defined('SYSPATH') or die('No direct access allowed.');

/**
 * This class provides Admin Product management
 *
 * @package    Product
 * @category   Controllers/Admin
 * @author     Deon George
 * @copyright  (c) 2009-2013 Open Source Billing
 * @license    http://dev.osbill.net/license.html
 */
class Controller_Admin_Product_Category extends Controller_TemplateDefault {
	protected $auth_required = TRUE;

	protected $secure_actions = array(
		'list'=>FALSE,
	);

	/**
	 * Show a list of products
	 */
	public function action_list() {
		$this->meta->title = 'A|Product Category List';

		$o = ORM::factory('Product_Category')->find_all()->as_array();
		Sort::MASort($o,array('name()'));

		Block::factory()
			->title('Product Categories')
			->title_icon('fa fa-list')
			->body(View::factory('product/category/list')->set('o',$o));
	}
}
?>
